/**
 * Cart Controller
 * @author Belkacem Alidra <belkacem.alidra@netoxygen.ch>
 */
TicketackControllers.controller('CartCtrl', function(
    $scope, $state, $sce, $document,
    Movies, Cart, Toast, Toast, LocalStorage) {

    /* Better to make http calls inside a ionic event handler... */
    $scope.$on('$ionicView.enter', function(e) {
        /* Let's save this screen as last state */
        LocalStorage.setObject('last_state', $state.current);
        LocalStorage.setObject('last_state_params', {});

        /* Reload th cart infos */
        Cart.get(function(err, cart) {
            if (!err)
                $scope.cart = cart;
        });
    });

    /* Remove an item from cart */
    $scope.remove_from_cart = function(index) {
        Toast.loading();

        Cart.remove(
            index,
            function(err) {
                Toast.hide();

                if (err)
                    return Toast.error('Une erreur est survenue');

                /* Reload the cart infos */
                Cart.get(function(err, cart) {
                    $scope.cart = cart;
                });
            }
        );
    }
});
