/**
 * Now Controller
 * @author Belkacem Alidra <belkacem.alidra@netoxygen.ch>
 */
TicketackControllers.controller('NowCtrl', function(
    $scope, $rootScope, $state,
    Toast, Movies, LocalStorage, _) {

    /* Better to make http calls inside a ionic event handler... */
    $scope.$on('$ionicView.beforeEnter', function(e) {
        /* Let's save this screen as last state */
        LocalStorage.setObject('last_state', $state.current);
        LocalStorage.setObject('last_state_params', {});
        
        /* running screenings */
        $scope.running_screenings     = [];
        /* Today screenings */
        $scope.today_screenings       = {};
        /* Array of start times */
        $scope.times                  = [];
        /* Number of screenings today */
        $scope.nb_of_today_screenings = 0;

        Toast.loading('');

        /* Fetch the movies: call the API only once */
        Movies.screenings(function(err, screenings) {
            if (err)
                return Toast.error();

            var times_screenings = {};
            _.each(screenings, function(s) {
                /* Keep only today screenings */
                /* Check if finished or running */
                if (moment().isAfter(moment(s.stop_at)) ||
                    moment().format('YYYY-MM-DD') != moment(s.start_at).format('YYYY-MM-DD'))
                    return false;

                /* Check if finished or running */
                if (moment().isAfter(moment(s.start_at)) &&
                    moment().isBefore(moment(s.stop_at)))
                    $scope.running_screenings.push(s);
                /* Group by start time */
                else {
                    var start_time = moment(s.start_at).format('HH:mm');
                    if (!_.contains($scope.times, start_time)) {
                        $scope.times.push(start_time);
                        $scope.today_screenings[start_time] = [];
                    }

                    $scope.today_screenings[start_time].push(s);
                }

                $scope.nb_of_today_screenings++;
            });

            $scope.times.sort();
            Toast.hide();
        });
    });
})
