/**
 * Pass Controller
 *
 * Show a pass bookings and access to the ticket pdf
 *
 * @author Belkacem Alidra <belkacem.alidra@netoxygen.ch>
 */
TicketackControllers.controller('PassCtrl', function(
    $scope, $rootScope,
    $ionicAnalytics, $stateParams,
    Cart, Tickets, Movies, Toast, LocalStorage, _) {

    /* The ticket bookings */
    $scope.bookings      = [];

    /* Get the current pass, if any */
    $scope.current_pass = Tickets.get_current_pass();

    /* Better to make http calls inside a ionic event handler... */
    $scope.$on('$ionicView.enter', function(e) {
        /* Let's login with this pass
         */
        $scope.login($stateParams.pass_id);
    });

    /**
     * Login the user with his ticket and refresh the ticket data
     */
    $scope.login = function(ticket_id) {
        Toast.loading();
        Tickets.get_pass(ticket_id, function(err, pass) {
            Toast.hide();
            if (err)
                return Toast.error();

            Toast.loading();
            Tickets.login(pass,
                function(err, pass) {
                    Toast.hide();

                    if (err)
                        return Toast.error('Une erreur est survenue');

                    $scope.current_pass = pass;
                }
            );
        });
    };

    /* Cancel a booking */
    $scope.cancel_booking = function(booking) {
        Toast.loading();
        Tickets.cancel_booking(booking._id, function(err, data) {
            Toast.hide();
            if (err)
                return Toast.error('Une erreur est survenue');

            /* Store in the screening the info that it is no more booked */
            booking.screening.already_booked --;

            /* Refresh the icket data */
            $scope.login($stateParams.pass_id);
        });
    };
});
