/**
 * Payment Controller
 * @author Belkacem Alidra <belkacem.alidra@netoxygen.ch>
 */
TicketackControllers.controller('PaymentCtrl', function(
    $scope, $ionicAnalytics,
    $sce, $timeout,
    Cart, Tickets, Toast) {

    Toast.loading(true);

    /* Better to make http calls inside a ionic event handler... */
    $scope.$on('$ionicView.enter', function(e) {

        /* Reload the cart */
        Cart.get(function(err, cart) {
            $scope.cart        = cart;
            $scope.payment_url = $sce.trustAsResourceUrl(cart.validate_cart_url);

            /* Track this event */
            $ionicAnalytics.track('Payment screen', {
                amount: cart.cart_amount
            });
        });
    });

    $scope.loaded = function() {
        $timeout(function() { Toast.hide(); }, 300);
        var child_angular =  document.getElementById("payment_frame").contentWindow.angular;
        if (child_angular && child_angular.element("#mobile_app_scope")) {
            var child_scope = child_angular.element("#mobile_app_scope").scope();
            if (child_scope) {
                Toast.loading('Récupération des achats');
                var activated_items = child_scope.activated_items;
                Tickets.store_activated_items(activated_items, function(err, items) {
                    Toast.hide();
                    if (err)
                        Toast.error();
                    else
                        Toast.success("Vos achats se trouvent dans l'onglet Billets");
                });
            }
        }


    }
});
