/**
 * Pdf Controller
 *
 * @author Belkacem Alidra <belkacem.alidra@netoxygen.ch>
 */
 TicketackControllers.controller('TicketPdfCtrl', function(
    $scope, $stateParams, $window,
    $ionicAnalytics, $sce, $timeout,
    Config, Cart, Toast, pdfDelegate) {

    Toast.loading(true);

    /* Hide the PDF dwhile it's not correctly resized */
    $scope.resized = false;

    /* Better to make http calls inside a ionic event handler... */
    $scope.$on('$ionicView.enter', function(e) {

        /* Refresh the cart */
        Cart.get(function(err, cart) {
            var pdf = pdfDelegate.$getByHandle('ticket-pdf');
            pdf.load(cart.view_ticket_url($stateParams.ticket_id));

            $ionicAnalytics.track('Ticket screen');
            $timeout(function() {
                /* Let's resize the PDF to fit the screen */
                var dims = Config.pos_tickets_size;
                pdf.zoomTo($window.innerWidth / dims.width);

                /* Let's show it */
                $scope.resized = true;

                Toast.hide();
            }, 1000);
        });
    });
});
