/**
 * Notification service
 * @author Belkacem Alidra <belkacem.alidra@netoxygen.ch>
 */
TicketackServices.factory('Toast', ['$ionicLoading', '$timeout', function($ionicLoading, $timeout) {
    return {
        error: function(message) {
            $ionicLoading.show({
                template: '<i class="ion-alert-circled"></i> ' + (message || ""),
                duration: 3000
            });
        },
        success: function(message) {
            $ionicLoading.show({
                template: '<i class="ion-android-done"></i> ' + (message || ""),
                duration: 1000
            });
        },
        loading: function(noBackdrop, message) {
            $ionicLoading.show({
                template: '<ion-spinner class="spinner-light" icon="ios"></ion-spinner> ' + (message || ""),
                noBackdrop: noBackdrop
            });
        },
        hide: function() {
            $ionicLoading.hide();
        }
    }
}])
